#!/bin/sh
#
# M/MONIT SQLITE TO SQL EXPORT
#
help()
{
       echo "Usage: $0 [-h|-d]"
       echo "Options are as follows:"
       echo " -d Specify the path to mmonit.db";
       echo " -h Print this text";
       echo "Use this script to dump data from a M/Monit SQLite database into a MySQL"
       echo "or a PostgreSQL database. Run this script from M/Monit's home directory"
       echo "or use the -d switch to specify the location of mmonit.db"
       echo "Examples:";
       echo " Export to MySQL: ./upgrade/migrate_db.sh | mysql -u mmonit mmonit -p"
       echo " Export to PostgreSQL: ./upgrade/migrate_db.sh | psql -U mmonit mmonit"
       exit 0;
}
error() 
{ 
        echo "Error: $1"; 
        exit 1; 
}
dump()
{
echo "DELETE FROM session;"
echo "DELETE FROM messagerecipients;"
echo "DELETE FROM message;"
echo "DELETE FROM messagequeue;"
echo "DELETE FROM messageformat;"
echo "DELETE FROM jabberserver;"
echo "DELETE FROM mailserver;"
echo "DELETE FROM actionrow;"
echo "DELETE FROM rulerow;"
echo "DELETE FROM rule;"
echo "DELETE FROM servicegroup;"
echo "DELETE FROM service;"
echo "DELETE FROM eventnotice;"
echo "DELETE FROM event;"
echo "DELETE FROM groupedhost;"
echo "DELETE FROM hostgroup;"
echo "DELETE FROM host;"
echo "DELETE FROM userroles;"
echo "DELETE FROM roles;"
echo "DELETE FROM users;"
sqlite3 $DBPATH << ELO
.mode insert users
SELECT * FROM users;
.mode insert roles
SELECT * FROM roles;
.mode insert userroles
SELECT * FROM userroles;
.mode insert host
SELECT * FROM host;
.mode insert hostgroup
SELECT * FROM hostgroup;
.mode insert groupedhost
SELECT * FROM groupedhost;
.mode insert event
SELECT * FROM event;
.mode insert eventnotice
SELECT * FROM eventnotice;
.mode insert service
SELECT * FROM service;
.mode insert servicegroup
SELECT * FROM servicegroup;
.mode insert rule
SELECT * FROM rule;
.mode insert rulerow
SELECT * FROM rulerow;
.mode insert actionrow
SELECT * FROM actionrow;
.mode insert mailserver
SELECT * FROM mailserver;
.mode insert jabberserver
SELECT * FROM jabberserver;
.mode insert messageformat
SELECT * FROM messageformat;
.mode insert messagequeue
SELECT * FROM messagequeue;
.mode insert message
SELECT * FROM message;
.mode insert messagerecipients
SELECT * FROM messagerecipients;
.mode insert session
SELECT * FROM session;
ELO
}

DBPATH="./db/mmonit.db"

while getopts ":hd:" c
do
case $c in
        d) DBPATH="${OPTARG:-$DBPATH}";;
        *) help;;
esac
done

if [ ! -e "$DBPATH" ]
then
        error "SQLite database file '$DBPATH' does not exist. Use -h for options";
else 
        dump;
fi

exit;
